--- app_voicemail.c	2007-05-23 14:38:05.000000000 -0400
+++ app_voicemail.c	2007-05-23 14:45:37.000000000 -0400
@@ -4405,6 +4405,9 @@
 	char category[32];
 	char todir[PATH_MAX];
 	int res = 0;
+	char *attachedfilename;
+        char *attachedfilefmt;
+        char *s;
 	char *temp;
 
 	vms->starting = 0; 
@@ -4426,7 +4429,23 @@
 	make_gsm_file(vms->fn, vms->imapuser, todir, vms->curmsg);
 
 	mail_fetchstructure (vms->mailstream,vms->msgArray[vms->curmsg],&body);
-	save_body(body,vms,"3","gsm");
+
+	/* We have the body, now we extract the file name of the first attachment. */
+        if (((body->nested.part->next) != NIL) && ((body->nested.part->next->body.parameter->value) != NIL) ) {
+                attachedfilename = body->nested.part->next->body.parameter->value;
+        } else {
+                ast_log(LOG_ERROR, "There is no file attached to this IMAP message.\n");
+                return -1;
+        }
+
+        /* Find the format of the attached file */
+        s = strdupa(attachedfilename);
+
+        for (i = 0; i < 2; i++) {
+                attachedfilefmt = strsep(&s, ".");
+        }
+
+        save_body(body,vms,"2",attachedfilefmt);
 
 	adsi_message(chan, vms);
 	if (!vms->curmsg)
